from sys import stdout

__all__ = ["cmd", "file"]


def progressbar(it, prefix="", size=60, out=stdout, sym: str = u"█"):
    count = len(it)

    def show(j):
        x = int(size * j / count)
        print("{}[{}{}] {}/{}".format(prefix, sym * x, "." * (size - x), j, count),
              end='\r', file=out, flush=True)

    show(0)
    for i, item in enumerate(it):
        yield item
        show(i + 1)
    print("\n", flush=True, file=out)


def rounds(num: float, _round: int = 0, warning: bool = False) -> float or int:
    if type(num) == int or _round == 0:
        return round(num)
    num_str = str(num)
    num_str_arr = []
    int_arr = []
    is_point = False
    for s in num_str:
        if s == ".":
            is_point = True
        if is_point:
            num_str_arr.append(s)
        else:
            int_arr.append(s)
    if len(num_str_arr) <= _round:
        return num
    try:
        nump = 0
        num_sub1 = num_str_arr[_round + 1]
        if int(num_sub1) >= 5:
            num_str_arr[_round] = str(int(num_str_arr[_round]) + 1)
        del num_str_arr[_round + 1:len(num_str_arr)]
        count = 0
        while int(num_str_arr[_round - count]) == 10:
            if num_str_arr[_round - count - 1] == ".":
                nump = 1
                num_str_arr[_round - count] = str(int(num_str_arr[_round - count]) - 10)
                break
            else:
                num_str_arr[_round - count - 1] = str(int(num_str_arr[_round - count - 1]) + 1)
                num_str_arr[_round - count] = str(int(num_str_arr[_round - count]) - 10)
                count += 1

        count = 0
        if nump:
            int_arr[-1] = str(int(int_arr[-1]) + 1)

        try:
            while int(int_arr[-1 - count]) == 10:
                int_arr[-1 - count - 1] = str(int(int_arr[-1 - count - 1]) + 1)
                int_arr[-1 - count] = str(int(int_arr[-1 - count]) - 10)
                count += 1

        except IndexError:
            int_arr.insert(0, "1")
            int_arr[-1 - count] = str(int(int_arr[-1 - count]) - 10)
        res = ""
        for i in int_arr:
            res += i
        for i in num_str_arr:
            res += i
        return float(res)
    except IndexError:
        if warning:
            print("\033[1;33;22mWarning IndexWarning: The range is greater than the decimal length\033[0m")
        return num


def ranges(range_x: int or float = 0, range_y: int or float = None, step: int or float = None):
    if range_y is None:
        range_y = range_x
        range_x = 0

    if step is None:
        if type(range_x) is float or type(range_y) is float and step is None:
            is_point = False
            decimals = []
            if type(range_y) is float:
                for get_float in str(range_y):
                    if is_point:
                        decimals.append(get_float)
                    if get_float == ".":
                        is_point = True
                range_C = 1
                for i in range(len(decimals)):
                    range_C *= 10
                step = 1 / range_C
            elif type(range_x) is float:
                for get_float in str(range_x):
                    if is_point:
                        decimals.append(get_float)
                    if get_float == ".":
                        is_point = True
                range_C = 1
                for i in range(len(decimals)):
                    range_C *= 10
                step = 1 / range_C
        else:
            step = 1
    y_decimals = []
    for index in range(len(str(range_y))):
        if str(range_y)[-index] == ".":
            break
        y_decimals.append(str(range_y)[-index])
    if range_x < range_y:
        while range_x <= range_y:
            yield range_x
            range_x = rounds(range_x + step, len(y_decimals))
    else:
        while range_x >= range_y:
            yield range_x
            range_x = rounds(range_x - step, len(y_decimals))


def decimal(obj: str or float) -> int or bool:
    if type(obj) == str:
        try:
            obj = float(obj)
        except ValueError:
            return False
    is_point = False
    decimals = []
    for get_float in str(obj):
        if is_point:
            decimals.append(get_float)
        if get_float == ".":
            is_point = True
    return len(decimals)


def rmdec(obj: float, x: int = 0, y: int = None) -> float:
    obj_list = list(str(obj))
    fnum = []
    inum = []
    is_point = False
    for i in obj_list:
        if is_point:
            fnum.append(i)
        else:
            inum.append(i)
        if i == ".":
            is_point = True
    if x >= 0 and y is None:
        del fnum[x:]
    elif x >= 0 and y is not None:
        del fnum[x:y]
    elif x < 0 and y is None:
        del fnum[:x]
    elif x < 0 and y is not None:
        del fnum[abs(x):abs(y)]
    res = ""
    for i in inum:
        res += i

    for i in fnum:
        res += i
    return float(res)



