import os
import sys


def install(module: str) -> None:
    version = str(sys.version_info.major)
    version += "." + str(sys.version_info.minor)
    os.system(f"pip{version} install --user {module}")

    return None


def move(path_obj: str, path_target: str) -> None:
    import shutil
    shutil.move(path_obj, path_target)

    return None


def get_Desktop() -> str:
    return os.path.join(os.path.expanduser("~"), 'Desktop')


def create_lnk(target: str, lnk_path: str = get_Desktop(), lnk_name: str = "Mylnks.lnk", icon: str = None, start=None):
    import win32com.client
    path = os.path.join(lnk_path, lnk_name)
    shell = win32com.client.Dispatch("WScript.Shell")
    shortcut = shell.CreateShortCut(path)
    shortcut.Targetpath = target
    if start is not None:
        shortcut.Workingdirectory = start
    if icon is not None:
        shortcut.IconLocation = icon
    shortcut.WindowStyle = 1  # 7 - Minimized, 3 - Maximized, 1 - Normal
    shortcut.save()


def installer(name=os.path.basename(sys.argv[0]), path=os.getcwd(), arg="-F", Has_installer=True):
    if not Has_installer:
        install("pyinstaller")
    os.system("cd {}".format(path))
    os.system("pyinstaller {} {}".format(arg, name))
    if "-F" not in arg:
        if move(path + r"\dist\{}.exe".format(name.strip(".py")), path):
            print("error")
        import shutil
        shutil.rmtree(path + r"\dist")
        shutil.rmtree(path + r"\build")


def package_setup_py(path):
    os.system(f"cd {path}")
    err = os.system("python setup.py sdist bdist_wheel")
    if err:
        os.system("python -m pip install –-user –-upgrade setuptools wheel")
        os.system("python setup.py sdist bdist_wheel")


def package_setup_cfg(path):
    os.system(f"cd {path}")
    err = os.system("py -m build")
    if err:
        os.system("py -m pip install --upgrade build")
        os.system("py -m build")


def upload():
    import os
    try:
        from . import setup
    except ImportError:
        class SetupImportError(Exception):
            pass
        raise SetupImportError("Please move the file to the setup.py directory")

    try:
        setuplist = list(setup.version)
    except NameError:
        class VersionValueNotFound(Exception):
            pass
        raise VersionValueNotFound("Please add a value of \"version\" and assign it your version")
    for i in range(len(setuplist)):
        try:
            setuplist[i] = int(setuplist[i])
        except ValueError:
            pass

    setuplist[-1] = setuplist[-1] + 1
    count = 0
    while setuplist[-1 - count] == 10:
        try:
            setuplist[-1 - count] = 0
            setuplist[-1 - count - 2] += 1
            count += 2
        except IndexError:
            setuplist.insert(0, 1)

    name = ""
    for i in setuplist:
        name += str(i)
    print(name)
    with open(f"{os.getcwd()}\\setup.py", "r") as f:
        lines = f.readlines()
    with open(f"{os.getcwd()}\\setup.py", "w") as f:
        for line in lines:
            if line.strip("\n") != f"version = \"{setup.version}\"":
                f.write(line)
            else:
                f.write(f"version = \"{name}\"\n")

    os.system(f"cd {os.getcwd()}")

    os.system("python setup.py sdist bdist_wheel")

    os.system("twine upload dist/*")

